#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_sdflagmanager import sdflagmanager
class sdflagmanager_cli_:
    __name__ = "sdflagmanager"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdflagmanager_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'mode':None, 'versionname':None, 'oldname':None, 'comment':None, 'merge':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, infile=None, mode=None, versionname=None, oldname=None, comment=None, merge=None, ):

        """ASAP SD task to manipulate flag version files

	Detailed Description: 

Task sdflagmanager enables users to save the current flag information 
(both channel and row flags) in the given SD dataset out to a separate 
'flag version file'. In the current implementation, sdflagmanager calls 
flagmanager internally, so these flag version files are copies of the 
flag columns for a measurement set actually. They can be restored to 
the data set to obtain a previous flag version. Users can also list, 
delete and rename flag version files using sdflagmanager. It is wise 
to save a flagversion at the beginning or after serious editing.    
  
	Arguments :
		infile:	name of input SD dataset (ASAP scantable)
		   Default Value: 

		mode:	operation mode
		   Default Value: list
		   Allowed Values:
				list
				save
				restore
				delete
				rename

		versionname:	Flag version name
		   Default Value: 

		oldname:	Flag version to rename
		   Default Value: 

		comment:	Short description of a versionname
		   Default Value: 

		merge:	Merge option: replace will save or over-write the flags
		   Default Value: replace

	Returns: void

	Example :

Keyword arguments:
infile -- name of input SD dataset
        default: ''
        example: infile='ngc5921.asap'
mode -- Flag version operation
        default: 'list';   to list existing flagtables
                 'save'    to copy flag columns of infile to a flag file
                 'restore' to place the specified flag file into infile
                 'delete'  to delete the specified flag file
                 'rename'  to rename the specified flag file
    >>> mode expandable parameters             
        versionname -- Flag version name
                default: none; example: versionname='original_data'
                No imbedded blanks in the versionname
        comment -- Short description of a versionname, when mode is 'save' 
                   or 'rename'
                default: ''
                example: comment='Clip above 1.85'
                         comment = versionname
        oldname -- When mode='rename', the flag file to rename
        merge -- merge operation
                options: 'or','and', but not recommended for now.
  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	casa = self.__globals__['casa']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdflagmanager'
        self.__globals__['taskname'] = 'sdflagmanager'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['mode'] = mode = self.parameters['mode']
            myparams['versionname'] = versionname = self.parameters['versionname']
            myparams['oldname'] = oldname = self.parameters['oldname']
            myparams['comment'] = comment = self.parameters['comment']
            myparams['merge'] = merge = self.parameters['merge']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['mode'] = mode
        mytmp['versionname'] = versionname
        mytmp['oldname'] = oldname
        mytmp['comment'] = comment
        mytmp['merge'] = merge
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.casac.utils().torecord(pathname+'sdflagmanager.xml')

        casalog.origin('sdflagmanager')
	try :
          #if not trec.has_key('sdflagmanager') or not casac.casac.utils().verify(mytmp, trec['sdflagmanager']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['sdflagmanager'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdflagmanager', 'sdflagmanager.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'sdflagmanager'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = sdflagmanager(infile, mode, versionname, oldname, comment, merge)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'sdflagmanager'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('sdflagmanager', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['mode']  = 'list'

        a['mode'] = {
                    0:{'value':'list'}, 
                    1:odict([{'value':'save'}, {'versionname':''}, {'comment':''}, {'merge':'replace'}]), 
                    2:odict([{'value':'restore'}, {'versionname':''}, {'merge':'replace'}]), 
                    3:odict([{'value':'delete'}, {'versionname':''}]), 
                    4:odict([{'value':'rename'}, {'oldname':''}, {'versionname':''}, {'comment':''}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdflagmanager', subkey=None):
        desc={'sdflagmanager': 'ASAP SD task to manipulate flag version files',
               'infile': 'name of input SD dataset (ASAP scantable)',
               'mode': 'operation mode [\'list\',\'save\',\'restore\',\'delete\', or \'rename\']',
               'versionname': 'Flag version name',
               'oldname': 'Flag version to rename',
               'comment': 'Short description of a versionname',
               'merge': 'Merge option: replace will save or over-write the flags',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['mode']  = 'list'
        a['versionname']  = ''
        a['oldname']  = ''
        a['comment']  = ''
        a['merge']  = 'replace'

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['mode']  == 'save':
            a['versionname'] = ''
            a['comment'] = ''
            a['merge'] = 'replace'

        if self.parameters['mode']  == 'restore':
            a['versionname'] = ''
            a['merge'] = 'replace'

        if self.parameters['mode']  == 'delete':
            a['versionname'] = ''

        if self.parameters['mode']  == 'rename':
            a['oldname'] = ''
            a['versionname'] = ''
            a['comment'] = ''

        if a.has_key(paramname) :
	      return a[paramname]
sdflagmanager_cli = sdflagmanager_cli_()
